﻿#region Copyright Notice
// ------------------------------------------------------------------------------ //
//                                                                                //
//               All contents copyright � Edward Nutting 2014                     //
//                                                                                //
//        You may not share, reuse, redistribute or otherwise use the             //
//        contents this file outside of the Fling OS project without              //
//        the express permission of Edward Nutting or other copyright             //
//        holder. Any changes (including but not limited to additions,            //
//        edits or subtractions) made to or from this document are not            //
//        your copyright. They are the copyright of the main copyright            //
//        holder for all Fling OS files. At the time of writing, this             //
//        owner was Edward Nutting. To be clear, owner(s) do not include          //
//        developers, contributors or other project members.                      //
//                                                                                //
// ------------------------------------------------------------------------------ //
#endregion
    
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kernel.FOS_System.Exceptions
{
    /// <summary>
    /// Represents a divide by zero exception.
    /// Usually thrown by hardware interrupt 0 when code attempts to divide a number (always integer?) by 0.
    /// </summary>
    public class DivideByZeroException : FOS_System.Exception
    {
        /// <summary>
        /// Sets the message to "Attempt to divide by zero invalid."
        /// </summary>
        public DivideByZeroException()
            : base("Attempt to divide by zero invalid.")
        {
        }
        /// <summary>
        /// Sets the message to "Attempt to divide by zero invalid. Address: [address]"
        /// </summary>
        /// <param name="address">The address of the instruction which caused the exception.</param>
        public DivideByZeroException(uint address)
            : base(((FOS_System.String)"Attempt to divide by zero invalid. Address: ") + address)
        {
        }
    }
}
